//+------------------------------------------------------------------+
//|PointAndFigure_TRO_MODIFIED_VERSION            PointAndFigure.mq4 |
//|                                 Copyright  2008, jlpiconsulting |
//|                                          jlpiconsulting@yahoo.fr |
//+------------------------------------------------------------------+
//| PointAndFigure_TRO_MODIFIED_VERSION                              |
//| MODIFIED BY AVERY T. HORTON, JR. AKA THERUMPLEDONE@GMAIL.COM     |
//| I am NOT the ORIGINAL author 
//  and I am not claiming authorship of this indicator. 
//  All I did was modify it. I hope you find my modifications useful.|
//|                                                                  |
//+------------------------------------------------------------------+
 
#property copyright "Copyright  2008, jlpiconsulting" 
#property link      "jlpiconsulting@yahoo.fr"
//----
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Yellow

extern color ColorUp   = Lime;      
extern color ColorDown = Red;  
//---- input parameters 
extern int BoxSize = 30; 
extern int MinBox = 3;
extern int WidthBox = 4;
//----
int Index = 0;
double     ind_buffer1[];
double     ind_buffer2[];
double     boxHi, boxLo;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(0,DRAW_NONE);
   SetIndexBuffer(0,ind_buffer1);
   
   SetIndexStyle(1,DRAW_NONE);
   SetIndexBuffer(1,ind_buffer2);   

  
//---- initialization done
   return(0);
  }


//+------------------------------------------------------------------+ 
//| Custom indicator deinitialization function                       | 
//+------------------------------------------------------------------+ 
int deinit() 
{ 
   for(int i = 0; i < 99999; i++) 
   {
       ObjectDelete("Box" + i);
       ObjectDelete("BoxBound" + i);
   }
   return(0); 
} 
//+------------------------------------------------------------------+ 
//|                                                    | 
//+------------------------------------------------------------------+ 
int start() 
{ 
  
   int i, j,k;
   bool found = false;
   int FirstBarIndex; 
   int NbCol, Trend; 
   double CurrentBox; 
   int Size;

   double BoxPoint = BoxSize*Point;
  
   FirstBarIndex = Bars - 1 ; 
   NbCol = 0; 
   CurrentBox = Open[FirstBarIndex]; 
   Trend = 0; 

   
// first pass to count the number of columns
   for(i = FirstBarIndex; i >= 1; i--)
   {   ind_buffer2[i] = 0 ;
       if (Trend == 0) // current down
       {
           found = false;
           while(Low[i] <= CurrentBox - BoxPoint) // search first for next down
           { 
               CurrentBox -= BoxPoint;  
               found = true; 
           } 
           if(found) 
               continue; 
           if(High[i] >= CurrentBox + MinBox*BoxPoint) // reverse, new column
           { 
               NbCol++; 
               Trend = 1; ind_buffer2[i] = 1 ;
               CurrentBox += MinBox*BoxPoint; 
               while(High[i] >= CurrentBox + BoxPoint) // search first for next up
               { 
                   CurrentBox += BoxPoint;  
               } 
           } 
       }
       if (Trend == 1) // current up
       {
           found = false;
           while(High[i] >= CurrentBox + BoxPoint) // search first for next up
           { 
               CurrentBox += BoxPoint;  
               found = true; 
           } 
           if(found) 
               continue; 
           if(Low[i] <= CurrentBox - MinBox*BoxPoint) // reverse, new column
           { 
               NbCol++; 
               Trend = 0; ind_buffer2[i] = 0 ;
               CurrentBox -= MinBox*BoxPoint; 
               while(Low[i] <= CurrentBox - BoxPoint) // search first for next down
               { 
                   CurrentBox -= BoxPoint;  
               } 
           } 
       }
   } 
   Size = (NbCol+2)*WidthBox;

/*

// second pass for drawing
   CurrentBox = Open[FirstBarIndex]; 
   Index = 0;
   for(i = FirstBarIndex; i >= 1; i--)
   { 
       if (Trend == 0) // current down
       {
           found = false;
           while(Low[i] <= CurrentBox - BoxPoint) // search first for next down
           { 
               CurrentBox -= BoxPoint;  
               DrawBox(Size,CurrentBox,ColorDown,1);
               found = true; 
               boxLo = Low[i] ; //tro
           } 
           if(found) 
               continue; 
           if(High[i] >= CurrentBox + MinBox*BoxPoint) // reverse, new column
           {   boxHi = High[i] ; //tro
               for(k = Size; k > Size - WidthBox; k--)
                  ind_buffer1[k] = CurrentBox-BoxPoint;

               Size-=WidthBox; 
               Trend = 1; ind_buffer2[i] = 1 ;
               for (j=0; j<MinBox; j++)
               {
                  CurrentBox += BoxPoint;
                  DrawBox(Size,CurrentBox,ColorUp,1);
               } 
               while(High[i] >= CurrentBox + BoxPoint) // search first for next up
               {   boxHi = High[i] ; //tro
                   CurrentBox += BoxPoint;  
                   DrawBox(Size,CurrentBox,ColorUp,1);
               } 
           } 
       }
       if (Trend == 1) // current up
       {
           found = false;
           while(High[i] >= CurrentBox + BoxPoint) // search first for next up
           { 
               CurrentBox += BoxPoint;  
               DrawBox(Size,CurrentBox,ColorUp,1);
               found = true; 
               boxHi = High[i] ; //tro
           } 
           if(found) 
               continue; 
           if(Low[i] <= CurrentBox - MinBox*BoxPoint) // reverse, new column
           {   boxLo = Low[i] ; //tro
               for(k = Size; k > Size - WidthBox; k--)
                  ind_buffer1[k] = CurrentBox+BoxPoint;

               Size-=WidthBox; 
               Trend = 0; ind_buffer2[i] = 0 ;
               for (j=0; j<MinBox; j++)
               {
                  CurrentBox -= BoxPoint;
                  DrawBox(Size,CurrentBox,ColorDown,1);
               } 
               while(Low[i] <= CurrentBox - BoxPoint) // search first for next down
               {   
                   CurrentBox -= BoxPoint;  
                   DrawBox(Size,CurrentBox,ColorDown,1);
               } 
           } 
       }
   } 


*/

   
   ind_buffer2[0] = Trend ;
   

 
   
   return(0); 
  }
//+------------------------------------------------------------------+ 

void DrawBox(int xaxis, double yaxis, color Color, int direction)
{
    int window;
    
    window = WindowFind("PointAndFigure");

    Index++;
    ObjectCreate("Box" + Index, OBJ_RECTANGLE, window, 0, 0, 0, 0);
    ObjectSet("Box" + Index, OBJPROP_TIME1, Time[xaxis]);
    ObjectSet("Box" + Index, OBJPROP_PRICE1, yaxis);
    ObjectSet("Box" + Index, OBJPROP_TIME2, Time[xaxis-WidthBox]);
    ObjectSet("Box" + Index, OBJPROP_PRICE2, yaxis+ direction*BoxSize*Point);
    ObjectSet("Box" + Index, OBJPROP_STYLE, STYLE_SOLID);
    ObjectSet("Box" + Index, OBJPROP_BACK, True);
    ObjectSet("Box" + Index, OBJPROP_COLOR, Color);
    ObjectCreate("BoxBound" + Index, OBJ_RECTANGLE, window, 0, 0, 0, 0);
    ObjectSet("BoxBound" + Index, OBJPROP_TIME1, Time[xaxis]);
    ObjectSet("BoxBound" + Index, OBJPROP_PRICE1, yaxis);
    ObjectSet("BoxBound" + Index, OBJPROP_TIME2, Time[xaxis-WidthBox]);
    ObjectSet("BoxBound" + Index, OBJPROP_PRICE2, yaxis+ direction*BoxSize*Point);
    ObjectSet("BoxBound" + Index, OBJPROP_STYLE, STYLE_SOLID);
    ObjectSet("BoxBound" + Index, OBJPROP_BACK, false);
    ObjectSet("BoxBound" + Index, OBJPROP_COLOR, White);

}


//+------------------------------------------------------------------+ 
/*  
   
   Comment( 
      "Period ", Period() , "\n",    
      "Trend ", DoubleToStr( Trend, Digits ), "\n",   
      "BoxHi ", DoubleToStr( boxHi, Digits ), "\n",
      "BoxLo ", DoubleToStr( boxLo, Digits ), "\n",
      "") ;   
   
*/

 