//+------------------------------------------------------------------+
//|   TRO_GANN_GRID                              GannRetracement.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"


#property indicator_chart_window

extern int  myBars      = 0;
extern int  gridBars    = 2;
extern int  gridWide    = 10;

extern color   Gann1Color = Yellow;
extern int     Gann1Width = 1;
extern int     Gann1Style = 2;

extern color   Gann2Color = DodgerBlue;
extern int     Gann2Width = 1;
extern int     Gann2Style = 2;

string fibo,fibo2;

int xBarsPerChart , barsToCount, hh, ll , i  ; 
int xFirstVisibleBar  ; 
double xPriceMax     ; 
double xPriceMin     ;

string symbol, tChartPeriod,  tShortName ;  
int    digits, period, digits2  ; 
double point ;

//+------------------------------------------------------------------+
int init()
{

    period = Period() ;     
//   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;
   
   fibo  = "GannA";
   fibo2 = "GannB";

   deinit() ;

   return(0); 
}

//+------------------------------------------------------------------+
int start()
{
  
   xBarsPerChart    = WindowBarsPerChart() ; 
   xFirstVisibleBar = WindowFirstVisibleBar() ; 
   xPriceMax        = WindowPriceMax() ; 
   xPriceMin        = WindowPriceMin() ;

   if(myBars == 0) { barsToCount = WindowBarsPerChart() ; } else { barsToCount = myBars; }

   
   int hh = Highest(symbol,period,MODE_HIGH,barsToCount,1);
   int ll = Lowest(symbol,period,MODE_LOW,barsToCount,1); 

   double xRES = iHigh(symbol,period,hh) ;  
   double xSUP = iLow(symbol,period,ll) ; 
   
   
      
int gg  = 0 ;

int gg4 = gridWide;



while(gg < barsToCount) 
{
       
   string sfibo = fibo + gg ;
   if( ObjectFind(sfibo)!=-1 )
   {  
      ObjectSet(sfibo,OBJPROP_TIME1,Time[gg]);
      ObjectSet(sfibo,OBJPROP_PRICE1,xRES);
       
   }
   else
   {
      ObjectCreate(sfibo,OBJ_TRENDBYANGLE,0,Time[gg],xRES);
      ObjectSet(sfibo,OBJPROP_ANGLE,315);    
      ObjectSet(sfibo,OBJPROP_COLOR,Gann1Color);
      ObjectSet(sfibo,OBJPROP_LEVELSTYLE,Gann1Style);
      ObjectSet(sfibo,OBJPROP_LEVELWIDTH,Gann1Width);
      ObjectSet(sfibo,OBJPROP_LEVELCOLOR,Gann1Color) ;  
         
   }


   string sfibo2 = fibo2 + gg + "b" ;   
   
   
   if( ObjectFind(fibo2)!=-1 )
   {
      ObjectSet(sfibo2,OBJPROP_TIME1,Time[gg]);
      ObjectSet(sfibo2,OBJPROP_PRICE1,xSUP);
 
   }
   else
   {

      ObjectCreate(sfibo2,OBJ_TRENDBYANGLE,0,Time[gg],xSUP );
      ObjectSet(sfibo2,OBJPROP_ANGLE,45);   
      ObjectSet(sfibo2,OBJPROP_COLOR,Gann2Color);  
      ObjectSet(sfibo2,OBJPROP_LEVELSTYLE,Gann2Style);
      ObjectSet(sfibo2,OBJPROP_LEVELWIDTH,Gann2Width) ; 
      ObjectSet(sfibo2,OBJPROP_LEVELCOLOR,Gann2Color) ; 
  
   }

   
   gg  = gg  + gridBars ;  
   gg4 = gg4 + gridBars;

       
} // while gg   
   
/*   
   
  gg  = x2;
  gg2 = x2 ;
  gg3 = x3 ;

while(  gg >= 0 && gg2 >= 0 && gg3 >= 0)
{

   
   string sfibo2 = fibo2 + gg + "b" ;   
   
   
   if( ObjectFind(fibo2)!=-1 )
   {
      ObjectSet(sfibo2,OBJPROP_TIME1,iTime(NULL,TimeFrame,gg2));
      ObjectSet(sfibo2,OBJPROP_PRICE1,y2);
      ObjectSet(sfibo2,OBJPROP_TIME2,iTime(NULL,TimeFrame,gg3));
      ObjectSet(sfibo2,OBJPROP_PRICE2,y3); 
   }
   else
   {

      ObjectCreate(sfibo2,OBJ_GANNLINE,0,iTime(NULL,TimeFrame,gg2),y2,iTime(NULL,TimeFrame,gg3),y3);
      ObjectSet(sfibo2,OBJPROP_COLOR,Gann2Color);  
      ObjectSet(sfibo2,OBJPROP_LEVELSTYLE,Gann2Style);
      ObjectSet(sfibo2,OBJPROP_LEVELWIDTH,Gann2Width) ; 
      ObjectSet(sfibo2,OBJPROP_LEVELCOLOR,Gann2Color) ; 
  
   }
   gg  = gg - 10 ;  
   gg2 = gg2 - 10;
   gg3 = gg3 - 10;
    
} // while gg   


*/

//----
   return(0);
}


//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
     
//+------------------------------------------------------------------+
int deinit()
  {
 
 ObDeleteObjectsByPrefix("Gann");    
 
   return(0);
}

//+------------------------------------------------------------------+


