//+------------------------------------------------------------------+ 
//|   TRO_PLOT                                                       | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 

#property indicator_chart_window

extern int    myShift       = 1 ;  
extern int    Line_Style    = STYLE_SOLID ;
extern int    Line_Width    = 2 ;

extern bool Plot.Open  = false ;
extern bool Plot.High  = true ;
extern bool Plot.Low   = true ;
extern bool Plot.Close = false ;
extern bool Plot.Pivot = true ;
extern bool Plot.MidPt = true ;

extern bool Show.Label = true ;
extern int  ShiftLabel =  0 ; 

extern bool show.M1  = false ;
extern bool show.M5  = false ;
extern bool show.M15 = true ;
extern bool show.H1  = true ;
extern bool show.H4  = true ;
extern bool show.D1  = true ;
extern bool show.W1  = true ;
extern bool show.MN1 = true ;


extern color color_M1  = Yellow ;
extern color color_M5  = Orange ;
extern color color_M15 = Red ;
extern color color_H1  = Bisque ; 
extern color color_H4  = Pink ;
extern color color_D1  = Purple ; 
extern color color_W1  = PaleGreen ;
extern color color_MN1 = DodgerBlue ;

string lbl[15], lbl2[15];
int n, j, i , lTime;

string symbol, tChartPeriod, ShortName ;  

int    digits, period, win ; 

double point,  open, high, low, close, diff, mid, range, pClose, pOpen, pHigh, pLow, pMid, pRange, cRange  ;   
 
 

double    HHprice, LLprice, OPprice, CLprice, PVprice, MDprice;
 
      
//+------------------------------------------------------------------+

int init()
{
   period = Period() ;

   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;
   ShortName    =  "trohl-"  + symbol + myShift ;
   
   ObDeleteObjectsByPrefix(ShortName);
 
   return(0);
  }
//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
      
//+------------------------------------------------------------------+
int deinit()
{
 
   ObDeleteObjectsByPrefix(ShortName); 
 
return(0);
}
  
//+------------------------------------------------------------------+
int start()
{

deinit();

n       = 10;
 
j       = 0 ;
 


if( show.M1 )  DoLabel( PERIOD_M1 , color_M1 ) ;
if( show.M5 )  DoLabel( PERIOD_M5 , color_M5 ) ;
if( show.M15 ) DoLabel( PERIOD_M15 , color_M15 ) ;
if( show.H1 )  DoLabel( PERIOD_H1 , color_H1 ) ;
if( show.H4 )  DoLabel( PERIOD_H4 , color_H4 ) ;
if( show.D1 )  DoLabel( PERIOD_D1 , color_D1 ) ;
if( show.W1 )  DoLabel( PERIOD_W1 , color_W1 ) ;
if( show.MN1 ) DoLabel( PERIOD_MN1 , color_MN1 ) ;

return(0);
}
 

//+------------------------------------------------------------------+
 
 
void DoLabel( int wPeriod , color wColor)
{

lTime   = 10 ;

HHprice = iHigh(symbol,wPeriod,myShift);  
LLprice = iLow(symbol,wPeriod,myShift);  
OPprice = iOpen(symbol,wPeriod,myShift);  
CLprice = iClose(symbol,wPeriod,myShift);  
PVprice = (HHprice + LLprice + CLprice) * 0.3333 ; 
MDprice = (HHprice + LLprice ) * 0.50 ; 


if(Plot.Low)
{ 
j       = j + 1 ;
lbl[j]  = ShortName+j+wPeriod;
drawLine(LLprice ,lbl[j], wColor , Line_Style, TimeFrameToString(wPeriod)+"("+ myShift +") Low"  ) ;
lTime   = lTime + 5 ;
}


if(Plot.High)
{ 
j       = j + 1 ;
lbl[j]  = ShortName+j+wPeriod;
drawLine(HHprice ,lbl[j], wColor , Line_Style, TimeFrameToString(wPeriod)+"("+ myShift +") High"  ) ; 
lTime   = lTime + 5 ;
}


if(Plot.Open)
{ 
j       = j + 1 ;
lbl[j]  = ShortName+j+wPeriod;
drawLine(OPprice ,lbl[j], wColor , Line_Style, TimeFrameToString(wPeriod)+"("+ myShift +") Open"  ) ;
lTime   = lTime + 5 ;
}


if(Plot.Close)
{ 
j       = j + 1 ;
lbl[j]  = ShortName+j+wPeriod;
drawLine(CLprice ,lbl[j], wColor , Line_Style, TimeFrameToString(wPeriod)+"("+ myShift +") Close"  ) ; 
}

if(Plot.MidPt)
{ 
j       = j + 1 ;
lbl[j]  = ShortName+j+wPeriod;
drawLine(MDprice ,lbl[j], wColor , Line_Style, TimeFrameToString(wPeriod)+"("+ myShift +") Midpt"  ) ; 
}

if(Plot.Pivot)
{ 
j       = j + 1 ;
lbl[j]  = ShortName+j+wPeriod;
drawLine(PVprice ,lbl[j], wColor , Line_Style, TimeFrameToString(wPeriod)+"("+ myShift +") PVprice"  ) ; 

}
 
  
}
 

//+------------------------------------------------------------------+
 
void drawLine(double lvl,string name, color Col,int type, string desc )
{
         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            ObjectSet(name, OBJPROP_STYLE, type);
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name, OBJPROP_WIDTH,Line_Width);
            ObjectSet(name, OBJPROP_BACK,true);
            
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            ObjectSet(name, OBJPROP_STYLE, type);
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,Line_Width);
            ObjectSet(name, OBJPROP_BACK,true);          
         }
 
if(Show.Label)
{ 
      if(ObjectFind(name+desc) != 0)
      {
         ObjectCreate(name+desc, OBJ_TEXT, 0, Time[lTime+ShiftLabel], lvl);
         ObjectSetText(name+desc, desc, 8, "Arial", Col);
      }
      else
      {
         ObjectMove(name+desc, 0, Time[lTime+ShiftLabel], lvl);
      } 
} 
 
}


//+--------- TRO MODIFICATION ---------------------------------------+  

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}
 
//+------------------------------------------------------------------+
/*

Comment(

"ind_bufferOp[0]" , ind_bufferOp[0] , "\n" ,   
 

"") ; 
*/