//+------------------------------------------------------------------+
//|                TRO_SIGMA_LINES                                   |
//|                                                                  |
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|                                                                  |
//|   therumpledone@gmail.com                                        |  
//+------------------------------------------------------------------+ 

#property  indicator_chart_window

extern int myShift        = 1 ;
extern int myLineStyle    = 2 ;
extern int myLineTickness = 1 ;

extern int    myPeriod = 0;
extern int    myBars   = 60;

extern double UpperDeviations1=1.0;
extern double LowerDeviations1=1.0;
extern double UpperDeviations2=2.0;
extern double LowerDeviations2=2.0;
extern double UpperDeviations3=3.0;
extern double LowerDeviations3=3.0;


extern color    iColor1=LightBlue; 
extern color    iColor2=Pink; 
extern color    iColor3=SlateBlue; 
extern color    iColor4=Brown; 
extern color    iColor5=SlateBlue; 
extern color    iColor6=Pink; 
extern color    iColor7=LightBlue; 
 

      string line1 = "sigmaline1" ;
      string line2 = "sigmaline2" ;      
      string line3 = "sigmaline3" ;
      string line4 = "sigmaline4" ;      
      string line5 = "sigmaline5" ;
      string line6 = "sigmaline6" ;      
      string line7 = "sigmaline7" ;
      
      
            
int          lastbar;

   double band1, band2,band3, band4,band5, band6 ;

string symbol, tChartPeriod ;  
int    digits , period , win  ; 

double point  ; 

int xBarsPerChart    ; 

//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
//+------------------------------------------------------------------+

int deinit()
  {
      ObjectDelete(line7);
      ObjectDelete(line6); 
      ObjectDelete(line5);
      ObjectDelete(line4); 
      ObjectDelete(line3); 
      ObjectDelete(line2); 
      ObjectDelete(line1);  
      
   return(0);
  }
 
//+------------------------------------------------------------------+
int init()
{



   if(myPeriod == 0) { period = Period() ; } else { period = myPeriod ; }       
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ; 

   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
   
   return(0);
}


//+------------------------------------------------------------------+
int start()
{

   
if(myBars == 0) { xBarsPerChart= WindowBarsPerChart();} else { xBarsPerChart = myBars ; }
 


      double ma     =     iMA(NULL,0,xBarsPerChart,0,MODE_SMA,PRICE_CLOSE,myShift);
      double stdDev = iStdDev(NULL,0,xBarsPerChart,0,MODE_SMA,PRICE_CLOSE,myShift);

      band1= ma+stdDev*UpperDeviations1;
      band2= ma-stdDev*LowerDeviations1;
      band3= ma+stdDev*UpperDeviations2;
      band4= ma-stdDev*LowerDeviations2;
      band5= ma+stdDev*UpperDeviations3;
      band6= ma-stdDev*LowerDeviations3;
      

      ObjectDelete(line7);
      ObjectCreate(line7,OBJ_HLINE,0,0,0);
      ObjectSet(line7,OBJPROP_COLOR,iColor7);
      ObjectSet(line7,OBJPROP_STYLE,myLineStyle);
 
      ObjectDelete(line6);
      ObjectCreate(line6,OBJ_HLINE,0,0,0);
      ObjectSet(line6,OBJPROP_COLOR,iColor6);
      ObjectSet(line6,OBJPROP_STYLE,myLineStyle);
 

      ObjectDelete(line5);
      ObjectCreate(line5,OBJ_HLINE,0,0,0);
      ObjectSet(line5,OBJPROP_COLOR,iColor5);
      ObjectSet(line5,OBJPROP_STYLE,myLineStyle);
 

      ObjectDelete(line4);
      ObjectCreate(line4,OBJ_HLINE,0,0,0);
      ObjectSet(line4,OBJPROP_COLOR,iColor4);
      ObjectSet(line4,OBJPROP_STYLE,myLineStyle);
 

      ObjectDelete(line3);
      ObjectCreate(line3,OBJ_HLINE,0,0,0);
      ObjectSet(line3,OBJPROP_COLOR,iColor3);
      ObjectSet(line3,OBJPROP_STYLE,myLineStyle);
      

      ObjectDelete(line2);
      ObjectCreate(line2,OBJ_HLINE,0,0,0);
      ObjectSet(line2,OBJPROP_COLOR,iColor2);
      ObjectSet(line2,OBJPROP_STYLE,myLineStyle);
 


      ObjectDelete(line1);
      ObjectCreate(line1,OBJ_HLINE,0,0,0);
      ObjectSet(line1,OBJPROP_COLOR,iColor1);
      ObjectSet(line1,OBJPROP_STYLE,myLineStyle);
  
      ObjectMove(line7,0,Time[0],band5);
 
      ObjectMove(line6,0,Time[0],band3);  
  
      ObjectMove(line5,0,Time[0],band1);
 
      ObjectMove(line4,0,Time[0],ma);
 
      ObjectMove(line3,0,Time[0],band2);      
 
      ObjectMove(line2,0,Time[0],band4);
 
      ObjectMove(line1,0,Time[0],band6);
            
           
   
   return (0);
}   

      
//+------------------------------------------------------------------+ 

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}
//+------------------------------------------------------------------+ 

