//+------------------------------------------------------------------+ 
//|   TRO_SPREAD_ALERT                                               | 
//|                                                                  | 
//|   Copyright  2008, AVERY T. HORTON, JR. AKA TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 

#property indicator_chart_window

extern bool   Sound.Alert    = true ;

  extern double    mySpreadMax = 9;
  extern double    mySpreadMin = 2;
  
  extern string note1 = "Change font colors automatically? True = Yes";
  extern bool   Bid_Ask_Colors = True;
  extern string note2 = "Default Font Color";
  extern color  FontColor = Blue;
  extern color  FontColorUp = Green;  
  extern color  FontColorDn = Red; 
  extern string note3 = "Font Size";
  extern int    FontSize=45;
  extern string note4 = "Font Type";
  extern string FontType="Arial Bold" ; //"Comic Sans MS";
  extern string note5 = "Display the price in what corner?";
  extern string note6 = "Upper left=0; Upper right=1";
  extern string note7 = "Lower left=2; Lower right=3";
  extern int    WhatCorner=0;
  extern int    xAxis=1;
  extern int    yAxis=40;


double   point, Old_Price, spread, Old_spread, AlertSpread;

string   symbol, tChartPeriod,  tShortName, tLabel, tMark, tAlert ;  
int      digits, period  ; 
datetime Trigger ;

//+------------------------------------------------------------------+
int init()
  {
  
   period       = Period() ;     
   tChartPeriod =  TimeFrameToString(period) ;  
   
   digits       =  Digits ;   
   point        =  Point ;

   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
  
   
   Old_spread = spread ;  
   spread = Ask - Bid ;
 
   tLabel = "SpReAd" + Symbol()   ;
   
   deinit() ;
   
   return(0);
  }


//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }  
//+------------------------------------------------------------------+
int deinit()
  {
   ObDeleteObjectsByPrefix("SpReAd");     
      
  return(0);
  }

//+------------------------------------------------------------------+
int start()
  {
  
  
  
Old_spread  = spread ;  
spread      = (Ask - Bid) / point ;
AlertSpread = spread ;
  
  
   if (Bid_Ask_Colors == True)
   {
      if (spread > Old_spread) FontColor = FontColorUp;
      if (spread < Old_spread) FontColor = FontColorDn; 
   }

  if( spread > mySpreadMax ) 
  {  
      tMark       = " >" ; 
      tAlert      = symbol + " Spread above mySpreadMax "+ DoubleToStr(mySpreadMax ,0) ; 
      AlertSpread = mySpreadMax ;
  } 
  else 
  if( spread < mySpreadMin ) 
  {  
      tMark = " <" ; 
      tAlert = symbol + " Spread below mySpreadMin "+ DoubleToStr(mySpreadMin ,0) ; 
      AlertSpread = mySpreadMin ;  }    
  else tMark = "" ;

      if ( Trigger != Time[0] &&  Sound.Alert ) 
      {   
        if( spread > mySpreadMax ) { Trigger = Time[0] ; Alert(tAlert); }
        if( spread < mySpreadMin ) { Trigger = Time[0] ; Alert(tAlert); }     
      }  
   
  
//   string tMessage = DoubleToStr(Bid, digits) + " " + Symbol() + " " + DoubleToStr(spread, 0) + tMark;
    
   string tMessage = Symbol() + " Spread "  + tMark + DoubleToStr(AlertSpread, 0);
  
   ObjectCreate(tLabel, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(tLabel, tMessage, FontSize, FontType, FontColor);
   ObjectSet(tLabel, OBJPROP_CORNER, WhatCorner);
   ObjectSet(tLabel, OBJPROP_XDISTANCE, xAxis);
   ObjectSet(tLabel, OBJPROP_YDISTANCE, yAxis);
   

   
  }
  
//+------------------------------------------------------------------+  

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}

//+------------------------------------------------------------------+    

/*

   
Comment( 

"tMark = ",  tMark , "\n",  
"spread = ", DoubleToStr(spread , digits), "\n",        
"mySpreadMax = ", DoubleToStr(mySpreadMax , digits), "\n",  
"mySpreadMin = ", DoubleToStr(mySpreadMin , digits), "\n", 
"") ;   

*/