//+------------------------------------------------------------------+ 
//| TRO_TP_SL                                                        | 



#property indicator_chart_window 
#property  indicator_buffers 7 
#property  indicator_color1  White 
#property  indicator_color2  Blue 
#property  indicator_color3  Red 
#property  indicator_color4  Green 
#property  indicator_color5  Green 


extern bool   Show.PriceBox  = true ;
extern int    myBoxWidth     = 2;
extern bool   show.comment   = false ;


extern double myProfitTarget   = 10 ;
extern double myStopLoss       = 7 ;

extern color colorASK         = White ;
extern color colorTargetTP    = Green ;
extern color colorTargetSL    = Red ;

double ASKLine[]; 
double TargetLineTP[]; 
double TargetLineSL[]; 

//+------------------------------------------------------------------+ 
string symbol, tChartPeriod,  tShortName ;  
int    digits2, digits, period, win ; 
double point;

double myEntryTrigger  ;

//+------------------------------------------------------------------+ 
int init() 
  { 

   period       = Period() ;   
   tChartPeriod =  TimeFrameToString(period) ;  
   digits       =  Digits ;
   point        =  Point ; 
   symbol       =  Symbol() ; 
   tShortName = symbol + tChartPeriod  ; 
    
  if(digits == 5 || digits == 3) { digits2 = 0 ; point = point * 10 ; } else { digits2 = 0 ; }
    
  
//---- indicators 
   SetIndexStyle(0,DRAW_LINE,STYLE_DOT); 
   SetIndexBuffer(0,ASKLine); 
     
      
   SetIndexStyle(3,DRAW_LINE,STYLE_DOT); 
   SetIndexBuffer(3,TargetLineTP); 
    
   SetIndexStyle(4,DRAW_LINE,STYLE_DOT); 
   SetIndexBuffer(4,TargetLineSL);      
//---- 
   return(0); 
  } 
  
//+------------------------------------------------------------------+ 

int deinit() 
  { 
   ObjectDelete(tShortName+"01"); 
   ObjectDelete(tShortName+"02"); 
   ObjectDelete(tShortName+"03"); 
   ObjectDelete(tShortName+"04");    
   ObjectDelete(tShortName+"05");    
   return(0); 
  } 
  
  
//+------------------------------------------------------------------+ 
int start() 
  { 
   int    counted_bars=IndicatorCounted(); 
   int limit; 
//---- 
   //---- last counted bar will be recounted 
   if(counted_bars>0) counted_bars--; 
    
   limit=Bars-counted_bars; 
    
    
   myEntryTrigger = Ask ; 
    
   for (int i=0; i<limit; i++) 
   {  
      ASKLine[i]      = myEntryTrigger; 
      TargetLineTP[i]   = myEntryTrigger+myProfitTarget*point; 
      TargetLineSL[i]   = myEntryTrigger-myStopLoss*point;    
   } 

string tTime = TimeToStr(Time[0]) ;

if(Show.PriceBox) { DoBox() ; }

if( show.comment )
{
Comment( "TPSL..... ", tTime, "\n", 

         "TP.... ", DoubleToStr(TargetLineTP[0],digits) , "\n",  

         "AskLine.... ", DoubleToStr(ASKLine[0],digits) ,"\n",                   
               
         "SL.... ", DoubleToStr(TargetLineSL[0],digits) , "\n",    
//         "point.... ", DoubleToStr(point,digits) , "\n",             
         "") ;
}

   return(0); 
  }  
  
//+--------- TRO MODIFICATION ---------------------------------------+  
void DoBox()    
{

       if (ObjectFind(tShortName+"01") != 0)
      {
          ObjectCreate(tShortName+"01",OBJ_ARROW,0,Time[0],TargetLineTP[0]);
          ObjectSet(tShortName+"01",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tShortName+"01",OBJPROP_COLOR,colorTargetTP);  
          ObjectSet(tShortName+"01",OBJPROP_WIDTH,myBoxWidth);  
      } 
      else
      {
         ObjectMove(tShortName+"01",0,Time[0],TargetLineTP[0]);
         ObjectSet(tShortName+"01",OBJPROP_COLOR,colorTargetTP);  
      }



 
       if (ObjectFind(tShortName+"03") != 0)
      {
          ObjectCreate(tShortName+"03",OBJ_ARROW,0,Time[0],ASKLine[0]);
          ObjectSet(tShortName+"03",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tShortName+"03",OBJPROP_COLOR,colorASK);  
          ObjectSet(tShortName+"03",OBJPROP_WIDTH,myBoxWidth);  
      } 
      else
      {
         ObjectMove(tShortName+"03",0,Time[0],ASKLine[0]);
         ObjectSet(tShortName+"03",OBJPROP_COLOR,colorASK);  
      }


      
       if (ObjectFind(tShortName+"05") != 0)
      {
          ObjectCreate(tShortName+"05",OBJ_ARROW,0,Time[0],TargetLineSL[0]);
          ObjectSet(tShortName+"05",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tShortName+"05",OBJPROP_COLOR,colorTargetSL);  
          ObjectSet(tShortName+"05",OBJPROP_WIDTH,myBoxWidth);  
      } 
      else
      {
         ObjectMove(tShortName+"05",0,Time[0],TargetLineSL[0]);
         ObjectSet(tShortName+"05",OBJPROP_COLOR,colorTargetSL);  
      }
                
   return(0);
}


//+--------- TRO MODIFICATION ---------------------------------------+  

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}



//+--------- TRO MODIFICATION ---------------------------------------+  